<?php declare(strict_types=1);

namespace Plugin\css_onlyCustomers\Migrations;

use JTL\Shop;
use JTL\Jtllog;


use JTL\Plugin\Migration;
use JTL\Update\IMigration;

/**
 * Class Migration20210429123301
 * @package Plugin\jtl_test\Migrations
 */
class Migration20210429123301 extends Migration implements IMigration {
	/**
	 * @inheritdoc
	 */

	public function copyTable($sourceDB, $destinationDB = "", $copyTable = true, $deleteSourceDB = false) {
		error_log('starte copy ' . $sourceDB);
		$result = $this->getDB()->query("SHOW TABLES LIKE '" . $sourceDB . "'", 2);
		if ($copyTable && $result !== null && is_array($result) && count($result)) {
			error_log('DB Vorhanden ' . $sourceDB);
			$result = $this->getDB()->query("SELECT * FROM " . $sourceDB . " WHERE 1", 2);
			foreach ($result as $oItem) {
				error_log('schreibe Datensatz nach ' . $destinationDB);
				$this->getDB()->insert($destinationDB, $oItem);
			}
		}
		if ($deleteSourceDB) {
			$this->execute("DROP TABLE IF EXISTS " . $sourceDB, 3);
		}
	}


	/*
	define('JTLLOG_LEVEL_EMERGENCY', 600);
	define('JTLLOG_LEVEL_ALERT', 550);
	define('JTLLOG_LEVEL_CRITICAL', 500);
	define('JTLLOG_LEVEL_ERROR', 400);
	define('JTLLOG_LEVEL_WARNING', 300);
	define('JTLLOG_LEVEL_NOTICE', 250);
	define('JTLLOG_LEVEL_INFO', 200);
	define('JTLLOG_LEVEL_DEBUG', 100);
*/

	public function JTLWriteLog($cLog = '', $nLevel = JTLLOG_LEVEL_INFO, $bForce = false) {
		if (\mb_strlen($cLog) > 0 && ($bForce || Jtllog::getSytemlogFlag(false))) {
			$logger = Shop::Container()->getLogService();
			$logger = $logger->withName("css_onlyCustomers");
			$logger->log($nLevel, $cLog, ["css_onlyCustomers"]);
			return true;
		}
		return false;
	}


	public function up() {
		$this->execute("
              CREATE TABLE IF NOT EXISTS `css_onlyCustomersConfig` (
                  `version` varchar(255) NOT NULL DEFAULT '3.0.0',
                  `sqlupdate` int(10) NOT NULL DEFAULT '0',
                  `pluginActive` char(1) NOT NULL default 'N',
                  `framework` char(3) NOT NULL default 'B4',
                  `css` text DEFAULT '.account-password >.row,
.login-form { 
justify-content: center; 
}',
                  `js` text NOT NULL,
                  `removeSelector` varchar(255) NOT NULL DEFAULT '#header-top-bar,#account h1,.register-wrapper,a.register,#mainNavigation,#shop-nav,,footer,#consent-manager,#copyright,.footnote-vat,.breadcrumb-container,#sidepanel_left',
                  `selector` varchar(255) NOT NULL DEFAULT '#content'
                ) ENGINE=InnoDB COLLATE utf8_unicode_ci
        ");


		$this->copyTable("css_onlyCustomers_konfig", "css_onlyCustomersConfig", true, false);


		$result = $this->getDB()->query(
			'SELECT * from `css_onlyCustomersConfig` where 1',
			2
		);

		if ($result === null || count($result) < 1) {
			$this->execute(
				"INSERT INTO `css_onlyCustomersConfig` (`version`) VALUES ('2.0.0')"
			);
		} else {
			$this->execute("UPDATE css_onlyCustomersConfig set `version` = '2.0.0' ");
		}
	}

	/**
	 * @inheritdoc
	 */
	public function down() {
	}
}
